-- Kleene algebra, following Dexter Kozen

-- # import Property

D : Set
(+) : D -> D -> D
(<=) : D -> D -> Prop

defLeq : (x:D) -> (y:D) -> (Eq D (x+y) y  <=>   x <= y)


axK : (x:D) -> (y:D) -> (z:D) ->
          (    Eq D (x + y) (y + x)
           /\  Eq D (x+ x) x
          )

--- cannot do this, though it does not look difficult ---
refLeq : (x:D) -> (y:D) -> ((x <= y /\ y <= x) <=> Eq D x y)
refLeq = \ x -> \ y -> fol-plugin(axK,defLeq)

